import track_function_call from "../../test/track_function_call.js";
import generate_id from "../../lib/generate_id.js";

const compile = (component_instance = {}, methods = {}) => {
  return Object.entries(methods).reduce(
    (methods = {}, [method_name, method_function]) => {
      methods[method_name] = (...args) => {
        track_function_call(`ui.${component_instance?.options?.test?.name || generate_id()}.methods.${method_name}`, [...args, {
          ...component_instance,
          setState: component_instance.setState.bind(component_instance),
          ...(component_instance.compile_render_methods() || {}),
        }]);

        return method_function(...args, {
          ...component_instance,
          setState: component_instance.setState.bind(component_instance),
          ...(component_instance.compile_render_methods() || {}),
        });
      };
      return methods;
    },
    {}
  );
};

export default compile;
